package no.ntnu.item.mopenid.util;

import java.io.BufferedReader;
import java.io.FileReader;
import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.SocketException;
import java.util.Enumeration;

import android.util.Log;

public class Utils {
	
	public static final String __PORT_DEFAULT = "8080";
	private static final String __MOPENID_WS_NAME = "mopenid";
	
	public static String getLocalEndpointURLAsString() {
		StringBuilder endpointAddress = new StringBuilder();
		endpointAddress.append("http://");
		try {
			String ip = getPublicIPasString();
			if (ip == null)
				throw new Exception("Can't obtain own IP address");
			endpointAddress.append(ip);
			endpointAddress.append(":" + Utils.__PORT_DEFAULT);
			endpointAddress.append("/" + Utils.__MOPENID_WS_NAME);
			endpointAddress.append("/server");

		} catch (Exception e) {
			System.out.println("Exception caught =" + e.getMessage());
			Log.i("eirik", "Failed building endpoint URL");
			return null;

		}

		return endpointAddress.toString();
	}
	
	public static String readFileAsString(String filePath)   throws java.io.IOException{
        StringBuffer fileData = new StringBuffer(1000);
        BufferedReader reader = new BufferedReader(
                new FileReader(filePath));
        char[] buf = new char[1024];
        int numRead=0;
        while((numRead=reader.read(buf)) != -1){
            String readData = String.valueOf(buf, 0, numRead);
            fileData.append(readData);
            buf = new char[1024];
        }
        reader.close();
        return fileData.toString();
    }
	
	private static String getPublicIPasString() {
		String ipaddress = null;
		try {
			for (Enumeration<NetworkInterface> en = NetworkInterface.getNetworkInterfaces(); en
					.hasMoreElements();) {
				NetworkInterface intf = (NetworkInterface) en.nextElement();
				for (Enumeration<InetAddress> enumIpAddr = intf.getInetAddresses(); enumIpAddr
						.hasMoreElements();) {
					InetAddress inetAddress = (InetAddress) enumIpAddr
							.nextElement();
					if (!inetAddress.isLoopbackAddress()) {
						ipaddress = inetAddress.getHostAddress().toString();
						Log.e("ip address", "" + ipaddress);
					}
				}
			}
		} catch (SocketException ex) {
			Log.e("Socket exception in GetIP Address of Utilities",
					ex.toString());
		}
		return ipaddress;
	}
	

}
