#!/bin/bash
mvn clean install
adb='/Users/eirikstien/Dev/android-sdk-mac_x86/platform-tools/./adb'
DEVICEID=$1

if [ -z $DEVICEID ] ; then
    echo "ERROR: Must provide device id"
    echo "Usage: $0 <deviceid>"
    echo ""
    $adb devices
    exit 1
fi

echo ""
echo "Looking for installed mOpenID ..."
$adb -s $DEVICEID shell pm list packages | grep mopenid
if [ $? == 0 ] ; then
  echo "Uninstalling existing mopenid ..."
  $adb -s $DEVICEID uninstall no.ntnu.item.mopenid.app
fi

echo ""
echo "Installing new mOpenID..."
APKFILE=`ls -1 target/mOpenIDApplication-*.apk | head -1`
$adb -s $DEVICEID install $APKFILE

echo ""
echo "Starting mopenid ..."
$adb -s $DEVICEID shell am start -a android.intent.action.MAIN \
 -c android.intent.category.LAUNCHER \
 -n no.ntnu.item.mopenid.app/.SelectMode


