package no.ntnu.item.mopenid.util;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;

public class MOpenIDDBOpenHelper extends SQLiteOpenHelper {
	private static final String DATABASE_NAME = "mopenid.db";
	private static final int DATABASE_VERSION = 9;
	public static final String MOPENID_ASSOCIATIONS_TABLE_NAME = "links";
	private static final String LINKS_TABLE_CREATE = "CREATE TABLE "
			+ MOPENID_ASSOCIATIONS_TABLE_NAME + " ("
			+ "_id TEXT PRIMARY KEY NOT NULL, " + "security_token TEXT,"
			+ "description TEXT,"+ "last_used TEXT," + "created TEXT DEFAULT CURRENT_TIMESTAMP"
			+ ");";

	public static final String MOPENID_GRANTED_TABLE_NAME = "sites";
	public MOpenIDDBOpenHelper(Context context) {
		super(context, DATABASE_NAME, null, DATABASE_VERSION);
	}

	public void onCreate(SQLiteDatabase db) {
		db.execSQL(LINKS_TABLE_CREATE);
	}

	@Override
	public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
		db.execSQL("DROP TABLE IF EXISTS links ");
		onCreate(db);
	}

}
