package no.ntnu.item.mopenid.util;

import android.content.ContentValues;

public class OpenID {

	private String identifier, lastUsed, description, created, securityToken;
	private boolean isCreateNewButton = false;;
	
	public OpenID(String id) {
		identifier = id;
		if(id.equals(">> Create new")) {
			isCreateNewButton = true;
		}
	}

	public boolean isCreateNewButton() {
		return isCreateNewButton;
	}

	public void setCreateNewButton(boolean isCreateNewButton) {
		this.isCreateNewButton = isCreateNewButton;
	}

	public OpenID(String id, String lastUsed) {
		this(id);
		this.lastUsed = lastUsed;
	}

	public String getIdentifier() {
		return identifier;
	}

	public void setIdentifier(String identifier) {
		this.identifier = identifier;
	}

	public String getLastUsed() {
		return lastUsed;
	}

	public void setLastUsed(String lastUsed) {
		this.lastUsed = lastUsed;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}
	
	
	public String toString() {
		return identifier;
	}

	public void setCreated(String created) {
		this.created = created;
	}

	public String getCreated() {
		return created;
	}

	public void setSecurityToken(String securityToken) {
		this.securityToken = securityToken;
	}

	public String getSecurityToken() {
		return securityToken;
	}
	public String toFormattedString() {
		return identifier+";"+lastUsed+";"+securityToken+";"+created+";"+description;
	}
	
	public ContentValues getContentValues() {
		ContentValues contentValues = new ContentValues();
		contentValues.put("_id", this.identifier);
		contentValues.put("last_used", this.lastUsed);
		contentValues.put("security_token", this.securityToken);
		contentValues.put("description", this.description);
		return contentValues;
	}
	
}
