package no.ntnu.item.mopenid.util;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.io.StringWriter;
import java.io.Writer;
import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.SocketException;
import java.net.URI;
import java.net.URISyntaxException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.List;
import java.util.Scanner;


import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.ResponseHandler;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.BasicResponseHandler;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONException;
import org.json.JSONObject;

import android.content.ComponentName;
import android.content.ContentResolver;
import android.content.ContentValues;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.Uri;
import android.net.wifi.WifiManager;
import android.telephony.TelephonyManager;
import android.util.Log;

public class Utils {
	public final static String MOPENID_WEBSERVICE_URL = "http://mopenid.item.ntnu.no/mopenid_ws/"; // TODO:
																						// make
																						// work
																						// for
																						// https
	public final static String MOPENID_URL = "https://mopenid.item.ntnu.no/id/";
	public final static int MAX_NUMBER_OF_IDS = 4;

	public static final String __PORT = "org.mortbay.ijetty.port";
	public static final String __NIO = "org.mortbay.ijetty.nio";
	public static final String __SSL = "org.mortbay.ijetty.ssl";

	public static final String __CONSOLE_PWD = "org.mortbay.ijetty.console";
	public static final String __PORT_DEFAULT = "8080";
	public static final boolean __NIO_DEFAULT = true;
	public static final boolean __SSL_DEFAULT = false;

	public static final String __CONSOLE_PWD_DEFAULT = "admin";

	private static final String JSON_RESPONSE_INSERTED = "inserted";
	private static final String JSON_RESPONSE_OK = "ok";
	private static final int ACTION_EXISTS = 0;
	private static final int ACTION_CREATE_NEW_IDENTIFIER = 1;
	private static final int ACTION_DELETE = 2;
	private static final int ACTION_ASSOCIATE_IDENTIFIER = 3;
	private static final int ACTION_DISASSOCIATE_IDENTIFIER = 4;
	private static final String __MOPENID_WS_NAME = "mopenid";
	private static final String JSON_LINK_ASSOCIATED_OK = "Link associated";
	private static final String JSON_LINK_DISASSOCIATED_OK = "Link disassociated";
	private static final String APN_PREFS_NAME = "APN_Preferences";
	private static SQLiteDatabase dbReadable, dbWriteable;
	private static final Uri CONTENT_URI = Uri
			.parse("content://telephony/carriers");
	private static final Uri PREFERRED_APN_URI = Uri
			.parse("content://telephony/carriers/preferapn");
	private static final String APN_DEFAULT_ID_KEY = "apn_current_id_key";
	private static final String APN_DEFAULT_NAME_KEY = "apn_current_name_key";
	private static final String[] SUPPORTED_APNS = new String[] {"internet"};

	private static boolean initialWifiStateSet = false;
	private static final String WIFI_ONSTART_STATE = "wifi_onStart_state";
	private static final String WIFI_PREFS = "wifi_prefs";
	private static WifiManager wifiManager = null;

	private static Context applicationContext;
	

	public static final boolean DEBUGMODE = false;

	public static Context getApplicationContext() {
		return applicationContext;
	}

	public static void setApplicationContext(Context applicationContext) {
		Utils.applicationContext = applicationContext;
		MOpenIDDBOpenHelper helper = new MOpenIDDBOpenHelper(applicationContext);
		dbWriteable = helper.getWritableDatabase();
	}

	public static Calendar parseTimestamp(String timestamp) throws Exception {
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		Date d = sdf.parse(timestamp);
		Calendar cal = Calendar.getInstance();
		cal.setTime(d);
		return cal;
	}

	public static String convertStreamToString(InputStream is)
			throws IOException {
		/*
		 * To convert the InputStream to String we use the Reader.read(char[]
		 * buffer) method. We iterate until the Reader return -1 which means
		 * there's no more data to read. We use the StringWriter class to
		 * produce the string.
		 */
		if (is != null) {
			Writer writer = new StringWriter();

			char[] buffer = new char[1024];
			try {
				Reader reader = new BufferedReader(new InputStreamReader(is,
						"UTF-8"));
				int n;
				while ((n = reader.read(buffer)) != -1) {
					writer.write(buffer, 0, n);
				}
			} finally {
				is.close();
			}
			return writer.toString();
		} else {
			return "";
		}
	}

	public static boolean registerNewID(String identifier) {

		HttpClient httpclient = new DefaultHttpClient();
		HttpGet request = new HttpGet(MOPENID_WEBSERVICE_URL + "associate.php?a="+ACTION_CREATE_NEW_IDENTIFIER+"&id="
				+ identifier);
		Log.i("eirik", "requesting: " + MOPENID_WEBSERVICE_URL + "associate.php?a="+ACTION_CREATE_NEW_IDENTIFIER+"&id="
				+ identifier);
		ResponseHandler<String> handler = new BasicResponseHandler();
		String result = "{\"message\":\"failed_std\"}";
		JSONObject jsonResult = null;
		try {
			result = httpclient.execute(request, handler);
			Log.i("eirik", "got it");
		} catch (ClientProtocolException e) {
			e.printStackTrace();
			Log.i("eirik", "execution failed due to an ClientProtocolException");
		} catch (IOException e) {
			e.printStackTrace();
			Log.i("eirik", "execution failed due to an IOException");
		} catch (Exception e) {
			Log.i("eirik", "execution failed due to an generic Exception");
			e.printStackTrace();
		} finally {
			try {
				jsonResult = new JSONObject(result);
			} catch (JSONException e) {
				Log.i("eirik", "JSON parsing failed");
				e.printStackTrace();
			}
		}

		if (jsonResult != null) {
			try {
				if (jsonResult.getString("message").equals(
						JSON_RESPONSE_INSERTED)) {
					OpenID openId = new OpenID(identifier);
					openId.setSecurityToken(jsonResult
							.getString("security_token"));
					// ContentValues newIdValues = new ContentValues();
					// newIdValues.put("_id", identifier);
					// newIdValues.put("security_token",
					// jsonResult.getString("security_token"));
					Log.i("eirik", "about to insert");
					return insertNewIdToDatabase(openId);

				}
			} catch (JSONException e) {
				Log.i("eirik", "JSON parsing failed: " + jsonResult.toString());
				e.printStackTrace();
			}
		}

		return false;

	}
	
	public static boolean deleteLastCreatedID(boolean deleteRemotelyToo) {
		MOpenIDDBOpenHelper helper = new MOpenIDDBOpenHelper(applicationContext);
		dbWriteable = helper.getWritableDatabase();
		Cursor result = dbWriteable.query(
				MOpenIDDBOpenHelper.MOPENID_ASSOCIATIONS_TABLE_NAME,
				new String[] { "_id" }, null, null, null, null, "created DESC");
		if (result.moveToFirst()) {
			return deleteId(result.getString(0), deleteRemotelyToo);
		}
		return false;
	}

	public static boolean insertNewIdToDatabase(OpenID newOpenId) {
		ContentValues openIdAsContentValues = newOpenId.getContentValues();
		Log.d("eirik","openid to insert: "+newOpenId.toFormattedString());
		return (dbWriteable.insert("links", null, openIdAsContentValues) != -1);
	}

	public static String isAvailable(String identifier) {
		HttpClient httpclient = new DefaultHttpClient();
		String result = "{\"message\":\"taken\"}";
		HttpGet request = new HttpGet(MOPENID_WEBSERVICE_URL + "exists.php?id="
				+ identifier);
		ResponseHandler<String> handler = new BasicResponseHandler();
		try {
			result = httpclient.execute(request, handler);
			Log.i("eirik", "got it");
		} catch (ClientProtocolException e) {
			e.printStackTrace();
			Log.i("eirik", "got it not");
		} catch (IOException e) {
			e.printStackTrace();
			Log.i("eirik", "got it never");
		} catch (Exception e) {
			Log.i("eirik", "got it huff huff");
			e.printStackTrace();
		}
		httpclient.getConnectionManager().shutdown();
		return result;
	}

	public static List<OpenID> getSavedOpenIDs() {
		Cursor result = dbWriteable.query(
				MOpenIDDBOpenHelper.MOPENID_ASSOCIATIONS_TABLE_NAME,
				new String[] { "_id", "last_used", "security_token", "created",
						"description" }, null, null, null, null, "created");

		List<OpenID> linkIDs = new ArrayList<OpenID>();
		if (result.moveToFirst()) {
			do {
				OpenID id = new OpenID(result.getString(0), result.getString(1));
				id.setLastUsed(result.getString(1));
				id.setSecurityToken(result.getString(2));
				id.setCreated(result.getString(3));
				id.setDescription(result.getString(4));
				linkIDs.add(id);
				Log.d("eirik", "got the id as follows: "+id.toFormattedString());

			} while (result.moveToNext());
		}
		result.close();
		return linkIDs;
	}

	public static void dbUpdateLastUsed(OpenID openid) {
		ContentValues updateValues = new ContentValues();
		updateValues.put("last_used", openid.getLastUsed());
		dbWriteable.update(MOpenIDDBOpenHelper.MOPENID_ASSOCIATIONS_TABLE_NAME,
				updateValues, "_id=?", new String[] { openid.getIdentifier() });

	}

	private static boolean deleteId(String identifier, boolean deleteRemotelyToo) {
		MOpenIDDBOpenHelper helper = new MOpenIDDBOpenHelper(applicationContext);
		boolean deletedRemotely = false;
		String securityToken = null;
		dbWriteable = helper.getWritableDatabase();
		Cursor result = dbWriteable.query(
				MOpenIDDBOpenHelper.MOPENID_ASSOCIATIONS_TABLE_NAME,
				new String[] { "security_token"}, "_id=?", new String[] {identifier}, null, null,"created DESC", "1");
		
		if(result.moveToFirst()) {
			securityToken = result.getString(0);
			if(deleteRemotelyToo) {
				JSONObject jsonResult = performServerRequest(identifier, securityToken, ACTION_DELETE);
				try {
					deletedRemotely = (jsonResult!=null && jsonResult.getString("message").equals("ok"));
				} catch (JSONException e) {
					e.printStackTrace();
				}
			}
			
		}
		
		if(deletedRemotely || !deleteRemotelyToo) {
			if(!deleteRemotelyToo) {
				Log.d("eirik", "Deleting the OpenID locally only");
			}
			return (-1 != dbWriteable.delete(MOpenIDDBOpenHelper.MOPENID_ASSOCIATIONS_TABLE_NAME, "_id=? AND security_token=?", 
					new String[] {identifier,securityToken})); //deleted completely
		}
		
		return false;
		
	}
	
	 

	private static String getSecurityTokenForIdentifier(String identifier) {
		String securityToken = null;
		Cursor result = dbWriteable.query(
				MOpenIDDBOpenHelper.MOPENID_ASSOCIATIONS_TABLE_NAME,
				new String[] { "security_token" }, "_id=?",
				new String[] { identifier }, null, null, "created DESC", "1");

		if (result.moveToFirst())
			securityToken = result.getString(0);
		result.close();
		return securityToken;
	}

	private static JSONObject performServerRequest(String identifier,
			String securityToken, int action) {
		JSONObject jsonResult = null;

		String phpFile = (ACTION_EXISTS == action) ? "exists" : "associate";
		HttpClient httpclient = new DefaultHttpClient();

		HttpGet request = new HttpGet(MOPENID_WEBSERVICE_URL + phpFile + ".php?a="
				+ action + "&id=" + identifier
				+ ((securityToken != null) ? "&st=" + securityToken : ""));
		ResponseHandler<String> handler = new BasicResponseHandler();
		String response = "{\"message\":\"failed_std\"}";
		try {
			response = httpclient.execute(request, handler);
		} catch (ClientProtocolException e) {
			e.printStackTrace();
			Log.i("eirik", "execution failed due to an ClientProtocolException");
		} catch (IOException e) {
			e.printStackTrace();
			Log.i("eirik", "execution failed due to an IOException");
		} catch (Exception e) {
			Log.i("eirik", "execution failed due to an generic Exception");
			e.printStackTrace();
		} finally {
			try {
				jsonResult = new JSONObject(response);
			} catch (JSONException e) {
				Log.i("eirik", "JSON parsing failed");
				e.printStackTrace();
			}
		}
		return jsonResult;
	}

	public static boolean linkGivenmOpenIDtoHere(String identifier) {
		String securityToken = getSecurityTokenForIdentifier(identifier);
		if (securityToken != null) {
			return linkWithmOpenIDServer(identifier, securityToken);
		}
		return false;
	}

	private static boolean linkWithmOpenIDServer(String identifier,
			String securityToken) {
		String localEndpointURL = getLocalEndpointURLAsString();
		HttpClient httpclient = new DefaultHttpClient();
		String requestString = "associate.php?a="+ACTION_ASSOCIATE_IDENTIFIER+"&id=" + identifier + "&st="
				+ securityToken + "&d=" + localEndpointURL;
		HttpGet request = new HttpGet(MOPENID_WEBSERVICE_URL + requestString);
		Log.i("eirik", "requesting: " + MOPENID_WEBSERVICE_URL + requestString);
		ResponseHandler<String> handler = new BasicResponseHandler();
		String result = "{\"message\":\"failed_std\"}";
		JSONObject jsonResult = null;
		try {
			result = httpclient.execute(request, handler);
			Log.i("eirik", "got it");
		} catch (ClientProtocolException e) {
			e.printStackTrace();
			Log.i("eirik", "execution failed due to an ClientProtocolException");
		} catch (IOException e) {
			e.printStackTrace();
			Log.i("eirik", "execution failed due to an IOException");
		} catch (Exception e) {
			Log.i("eirik", "execution failed due to an generic Exception");
			e.printStackTrace();
		} finally {
			try {
				jsonResult = new JSONObject(result);
			} catch (JSONException e) {
				Log.i("eirik", "JSON parsing failed");
				e.printStackTrace();
			}
		}

		if (jsonResult != null) {
			try {
				if (jsonResult.getString("message").equals(
						JSON_LINK_ASSOCIATED_OK)) {
					return true;

				}
			} catch (JSONException e) {
				Log.i("eirik", "JSON parsing failed: " + jsonResult.toString());
				e.printStackTrace();
			}
		}
		return false;

	}

	public static String getLocalEndpointURLAsString() {
		StringBuilder endpointAddress = new StringBuilder();
		endpointAddress.append("http://");
		try {
			String ip = getPublicIPasString();
			if (ip == null)
				throw new Exception("Can't obtain own IP address");
			endpointAddress.append(ip);
			endpointAddress.append(":" + Utils.__PORT_DEFAULT);
			endpointAddress.append("/" + Utils.__MOPENID_WS_NAME);
			endpointAddress.append("/server");

		} catch (Exception e) {
			System.out.println("Exception caught =" + e.getMessage());
			Log.i("eirik", "Failed building endpoint URL");
			return null;

		}

		return endpointAddress.toString();
	}

	private static String getPublicIPasString() {
		String ipaddress = null;
		try {
			for (Enumeration en = NetworkInterface.getNetworkInterfaces(); en
					.hasMoreElements();) {
				NetworkInterface intf = (NetworkInterface) en.nextElement();
				for (Enumeration enumIpAddr = intf.getInetAddresses(); enumIpAddr
						.hasMoreElements();) {
					InetAddress inetAddress = (InetAddress) enumIpAddr
							.nextElement();
					if (!inetAddress.isLoopbackAddress()) {
						ipaddress = inetAddress.getHostAddress().toString();
						Log.e("ip address", "" + ipaddress);
					}
				}
			}
		} catch (SocketException ex) {
			Log.e("Socket exception in GetIP Address of Utilities",
					ex.toString());
		}
		return ipaddress;
		//
		// String ip = null;
		// try {
		// URL autoIP = new URL(
		// "http://www.whatismyip.com/automation/n09230945.asp");
		// BufferedReader in = new BufferedReader(new InputStreamReader(
		// autoIP.openStream()));
		// ip = (in.readLine()).trim();
		//
		// } catch (Exception e) {
		// e.printStackTrace();
		//
		// }
		// return ip;
	}

	public static boolean disassociateOpenID(String identifier) {
		String securityToken = getSecurityTokenForIdentifier(identifier);
		if (securityToken != null) {
			return unlinkWithmOpenIDServer(identifier, securityToken);
		}
		return false;

	}

	private static boolean unlinkWithmOpenIDServer(String identifier,
			String securityToken) {

		HttpClient httpclient = new DefaultHttpClient();
		String requestString = "associate.php?a="+ACTION_DISASSOCIATE_IDENTIFIER+"&id=" + identifier + "&st="
				+ securityToken;
		HttpGet request = new HttpGet(MOPENID_WEBSERVICE_URL + requestString);
		Log.i("eirik", "requesting: " + MOPENID_WEBSERVICE_URL + requestString);
		ResponseHandler<String> handler = new BasicResponseHandler();
		String result = "{\"message\":\"failed_std\"}";
		JSONObject jsonResult = null;
		try {
			result = httpclient.execute(request, handler);
			Log.i("eirik", "got it");
		} catch (ClientProtocolException e) {
			e.printStackTrace();
			Log.i("eirik", "execution failed due to an ClientProtocolException");
		} catch (IOException e) {
			e.printStackTrace();
			Log.i("eirik", "execution failed due to an IOException");
		} catch (Exception e) {
			Log.i("eirik", "execution failed due to an generic Exception");
			e.printStackTrace();
		} finally {
			try {
				jsonResult = new JSONObject(result);
			} catch (JSONException e) {
				Log.i("eirik", "JSON parsing failed");
				e.printStackTrace();
			}
		}

		if (jsonResult != null) {
			try {
				if (jsonResult.getString("message").equals(
						JSON_LINK_DISASSOCIATED_OK)) {
					Log.i("eirik", "disassociated mmkay");
					return true;

				}
			} catch (JSONException e) {
				Log.i("eirik", "JSON parsing failed: " + jsonResult.toString());
				e.printStackTrace();
			}
		}
		return false;
	}

	public static void saveCurrentAndSwitchToPublicAPN(Context context) {
		saveCurrentApn(context);
		SharedPreferences settings = context.getSharedPreferences(
				APN_PREFS_NAME, 0);
		long defaultApnId = (long) settings.getLong(APN_DEFAULT_ID_KEY, -1);
		String defaultApnName = settings.getString(APN_DEFAULT_NAME_KEY, "");

		if (apnIsSupported(defaultApnName)	&& !isPublicAlready(context.getContentResolver())) {
			setApnAsPublic(context.getContentResolver(), defaultApnId,
					defaultApnName);
		} else {
			Log.d("eirik", "Current APN not supported or is already public!");
		}

	}

	public static boolean isPublicAndConnectedAlready(Context context) {
		boolean isConnectedToMobileNetwork = isConnectedToMobileNetwork(context);
		boolean isPublicAlready = isPublicAlready(context.getContentResolver());
		return isPublicAlready && isConnectedToMobileNetwork;
	}

	private static boolean isConnectedToMobileNetwork(Context context) {
		TelephonyManager telephonyManager = (TelephonyManager) context
        .getSystemService(Context.TELEPHONY_SERVICE);;
        int connId = telephonyManager.getDataState();
        switch(connId) {
        	
        }
        
        Log.d("eirik", "");
		ConnectivityManager connectivityManager = (ConnectivityManager) context
				.getSystemService(Context.CONNECTIVITY_SERVICE);
		NetworkInfo networkInfo = connectivityManager.getActiveNetworkInfo();
		if (networkInfo != null) {
			return networkInfo.getType() == ConnectivityManager.TYPE_MOBILE
					&& networkInfo.isConnected();
		}
		return false;
	}

	public static boolean isPublicAlready(ContentResolver contentResolver) {
		Cursor cursor = contentResolver.query(CONTENT_URI,
				new String[] { "_id, apn" }, "current=1", null, null);
		cursor.moveToFirst();
		if (!cursor.isAfterLast()) {
			return cursor.getString(1).contains(".public");
		}
		cursor.close();
		return false;
	}

	private static void setApnAsPublic(ContentResolver contentResolver,
			long defaultApnId, String defaultApnName) {
		ContentValues values = new ContentValues();
		String publicApnName = defaultApnName + ".public";
		values.put("apn", publicApnName);
		contentResolver.update(CONTENT_URI, values, "_id=?",
				new String[] { String.valueOf(defaultApnId) });

	}

	private static boolean apnIsSupported(String defaultApnName) {
		for (int i = 0; i < SUPPORTED_APNS.length; i++) {
			if (SUPPORTED_APNS[i].equals(defaultApnName.replace(".public", ""))) {
				Log.i("apn", "APN is supported ("+defaultApnName+")");
				return true;
			} else {
				Log.i("apn", "APN is NOT supported ("+defaultApnName+")");
			}
		}
		return false;
	}

	private static void saveCurrentApn(Context context) {
		SharedPreferences settings = context.getSharedPreferences(
				APN_PREFS_NAME, 0);
		if (!settings.contains(APN_DEFAULT_ID_KEY)) {
			HashMap<Long, String> result = getCurrentApn(context
					.getContentResolver());
			long apnId = (long) result.keySet().iterator().next();
			String apnName = result.values().iterator().next();
			if (apnName.contains(".public"))
				return;
			Log.i("eirik", "this is the current apn id: " + apnId + ""
					+ " and name: " + apnName);

			SharedPreferences.Editor editor = settings.edit();
			editor.putLong(APN_DEFAULT_ID_KEY, apnId);
			editor.putString(APN_DEFAULT_NAME_KEY, apnName);
			editor.commit();
		}

	}

	public static HashMap<Long, String> getCurrentApn(ContentResolver contentResolver) {
		HashMap<Long, String> result = new HashMap<Long, String>();
		Cursor cursor = contentResolver.query(CONTENT_URI,
				new String[] { "_id, apn" }, "current=1", null, null);
		cursor.moveToFirst();
		Log.d("apn", "In getCurrentApn()  number of apns with current=1: "+cursor.getCount());
		if (!cursor.isAfterLast()) {
			result.put(Long.valueOf(cursor.getLong(0)), cursor.getString(1));
		}
		cursor.close();
		return result;
	}

	public static void restoreApnSettingToNormal(Context context) {
		SharedPreferences settings = context.getSharedPreferences(
				APN_PREFS_NAME, 0);
		long defaultApnId = (long) settings.getLong(APN_DEFAULT_ID_KEY, -1);
		String defaultApnName = settings.getString(APN_DEFAULT_NAME_KEY, null);
		if (defaultApnName != null && apnIsSupported(defaultApnName)) {
			ContentValues values = new ContentValues();
			values.put("apn", defaultApnName);
			context.getContentResolver()
					.update(CONTENT_URI, values, "_id" + "=?",
							new String[] { String.valueOf(defaultApnId) });
			Log.i("eirik", "Restored APN settings to apn=" + defaultApnName
					+ " at _id=" + defaultApnId);
		} else {
			Log.i("eirik", "Unsupported APN name: \"" + defaultApnName
					+ "\". Couldn't restore.");
		}

	}

	public static boolean isPublic(Context context) {
		HashMap<Long, String> current = getCurrentApn(context
				.getContentResolver());
		return current.values().iterator().next().contains(".public");
	}

	public static void saveInitialWifiState(Context context) {
		if (wifiManager == null)
			wifiManager = (WifiManager) context
					.getSystemService(Context.WIFI_SERVICE);

		if (!initialWifiStateSet) {
			SharedPreferences settings = context.getSharedPreferences(
					WIFI_PREFS, 0);
			SharedPreferences.Editor editor = settings.edit();
			editor.putBoolean(WIFI_ONSTART_STATE, wifiManager.isWifiEnabled());
			editor.commit();
			initialWifiStateSet = true;
			Log.i("eirik", "setting the prefs");
		}

		SharedPreferences settings = context
				.getSharedPreferences(WIFI_PREFS, 0);
		if (settings.contains(WIFI_ONSTART_STATE)) {
			Log.i("eirik",
					"wifi was enabled on initial launch: "
							+ settings.getBoolean(WIFI_ONSTART_STATE, false));
		}

	}

	public static void resetToInitialWifiState(Context context) {
		if (wifiManager == null)
			wifiManager = (WifiManager) context
					.getSystemService(Context.WIFI_SERVICE);
		SharedPreferences settings = context
				.getSharedPreferences(WIFI_PREFS, 0);
		if (settings.contains(WIFI_ONSTART_STATE)) {
			boolean initialState = settings.getBoolean(WIFI_ONSTART_STATE,
					false);
			wifiManager.setWifiEnabled(initialState);
			SharedPreferences.Editor editor = settings.edit();
			editor.remove(WIFI_ONSTART_STATE);
		}
		initialWifiStateSet = false;

	}

	public static void disableWifi(Context context) {
		if (wifiManager == null)
			wifiManager = (WifiManager) context
					.getSystemService(Context.WIFI_SERVICE);
		if (wifiManager.getWifiState() != WifiManager.WIFI_STATE_DISABLED) {
			wifiManager.setWifiEnabled(false);
		}

	}

	public static boolean isCorrectDecryptionKey(String decryptedText) {
		if (decryptedText == null || decryptedText.length() < 3)
			return false;
		String[] lines = decryptedText.split("\n");
		return lines[0].equals(BackupUtils.OKAY_FLAG);

	}
	
	public static boolean isWifiEnabled() {
		return wifiManager.isWifiEnabled();
	}

	public static boolean idAlreadyExists(OpenID openID) {
		Cursor result = dbWriteable.query(
				MOpenIDDBOpenHelper.MOPENID_ASSOCIATIONS_TABLE_NAME,
				new String[] { "_id" }, "_id=?",
				new String[] { openID.getIdentifier() }, null, null, null, null);
		
		return result.moveToFirst();
	}

	public static String fetchStringFromUri(Uri uri) throws URISyntaxException, FileNotFoundException {
		String result = null;
		
		if(uri.getScheme().equalsIgnoreCase("https") || uri.getScheme().equalsIgnoreCase("http") ) {
			URI httpuri = URI.create(uri.toString());
			
			HttpClient httpclient = new DefaultHttpClient();
			
			
			HttpGet request = new HttpGet(httpuri);
			ResponseHandler<String> handler = new BasicResponseHandler();
			try {
				result = httpclient.execute(request, handler);
				Log.i("eirik", "got it");
			} catch (ClientProtocolException e) {
				e.printStackTrace();
				Log.i("eirik", "got it not");
			} catch (IOException e) {
				e.printStackTrace();
				Log.i("eirik", "got it never");
			} catch (Exception e) {
				Log.i("eirik", "got it huff huff");
				e.printStackTrace();
			}
			httpclient.getConnectionManager().shutdown();
			return result;
		} else if (uri.getScheme().equalsIgnoreCase("file")) {
			File encryptedFile = new File(new URI(uri.toString()));

			Scanner scanner = new Scanner(encryptedFile).useDelimiter("\\Z");
			    result = scanner.next();
		}
		
		
		
		return result;
	}

	public static void startIJettyService() {
		
        Intent intent = new Intent("android.intent.action.MAIN");
        intent.setComponent(new ComponentName("org.mortbay.ijetty", "org.mortbay.ijetty.IJettyService"));
        intent.addCategory("android.intent.category.LAUNCHER");
        
       
        intent.putExtra(__PORT,__PORT_DEFAULT);
        intent.putExtra(__NIO,__NIO_DEFAULT);
        intent.putExtra(__SSL,__SSL_DEFAULT);
        intent.putExtra(__CONSOLE_PWD,__CONSOLE_PWD_DEFAULT);
        applicationContext.startService(intent);
		
	}
	
	public static void stopIJettyService() {
		Intent intent = new Intent();
		intent.setComponent(new ComponentName("org.mortbay.ijetty", "org.mortbay.ijetty.IJettyService"));
		applicationContext.stopService(intent);
	}

	public static boolean apnSettingsSupported() {
		HashMap<Long, String> current = getCurrentApn(applicationContext.getContentResolver());
		if(current.size() > 0) {
			return apnIsSupported(current.values().iterator().next());
		}
		return false;
	}

	public static String getCurrentApnName() {
		HashMap <Long, String> current = getCurrentApn(applicationContext.getContentResolver());
		if(current.size() == 1) {
			String apnName = current.values().iterator().next();
			Log.d("apn", "Current APN name: "+apnName);
			return apnName;
		}
		return null;
	}

	public static boolean deleteId(OpenID idToDelete, boolean deleteRemotelyToo) {
			return deleteId(idToDelete.getIdentifier(), deleteRemotelyToo);
	}

	public static boolean dataEnabled() {
		ConnectivityManager connectivityManager = (ConnectivityManager) applicationContext
				.getSystemService(Context.CONNECTIVITY_SERVICE);
		NetworkInfo[] networkInfo = connectivityManager.getAllNetworkInfo();
		if (networkInfo != null) {
			for (int i = 0; i < networkInfo.length; i++) {
				Log.d("eirik", "reason: "+networkInfo[i].getReason());
				if (networkInfo[i].getReason() == null) { continue; }
				if(networkInfo[i].getType() == ConnectivityManager.TYPE_MOBILE
						&& (!networkInfo[i].getReason().equals("dataDisabled"))) { // somewhat bad hack/fix
					return true;
				}
			}
		}
		return false;
	}
}
